## wireshark-4.7.0rc0-1571-g59eba0ae571e.tar.xz

=== CMakeLists.txt ===
# CMakeLists.txt
#
# Wireshark - Network traffic analyzer
# By Gerald Combs <gerald@wireshark.org>
# Copyright 1998 Gerald Combs
#
# SPDX-License-Identifier: GPL-2.0-or-later
#
if(DEFINED ENV{FORCE_CMAKE_NINJA_NON_VERBOSE})
	#
	# Forcibly unset CMAKE_VERBOSE_MAKEFILE,
	# to make *CERTAIN* that we don't do
	# anything verbose here!
	#
	unset(CMAKE_VERBOSE_MAKEFILE CACHE)
endif()

# https://doc.qt.io/qt-6/cmake-supported-cmake-versions.html
cmake_minimum_required(VERSION 3.20)
if(POLICY CMP0127)
	cmake_policy(SET CMP0127 NEW)
endif()
if(POLICY CMP0135)
	cmake_policy(SET CMP0135 NEW)
endif()

if(WIN32 AND NOT DEFINED ENV{MSYSTEM})
	set(_project_name Wireshark)
	set(STRATOSHARK_NAME Stratoshark)
else()
	set(_project_name wireshark)
	set(STRATOSHARK_NAME stratoshark)
endif()

project(${_project_name} C CXX)

if(WIN32)
	set(_msystem False)
	set(_repository False)
	if(DEFINED ENV{MSYSTEM})
		set(_msystem $ENV{MSYSTEM})
		message(STATUS "Using MSYS2 with MSYSTEM=${_msystem}")
	elseif(MSVC)
		set(_repository True)
		message(STATUS "Using 3rd party repository")
	else()
		# Neither own package repository nor MSYS2 repository.
	endif()
	set(USE_MSYSTEM ${_msystem} CACHE INTERNAL "Use MSYS2 subsystem")
	set(HAVE_MSYSTEM ${USE_MSYSTEM}) # For config.h
	set(USE_REPOSITORY ${_repository} CACHE INTERNAL "Use Wireshark 3rd Party Repository")
endif()

# Updated by tools/make-version.py
set(PROJECT_MAJOR_VERSION 4)
set(PROJECT_MINOR_VERSION 7)
set(PROJECT_PATCH_VERSION 0)
set(PROJECT_BUILD_VERSION 0)
set(PROJECT_VERSION_EXTENSION "rc0-1571-g59eba0ae571e")

if(DEFINED ENV{WIRESHARK_VERSION_EXTRA})
	set(PROJECT_VERSION_EXTENSION "$ENV{WIRESHARK_VERSION_EXTRA}")
endif()

set(PROJECT_VERSION "${PROJECT_MAJOR_VERSION}.${PROJECT_MINOR_VERSION}.${PROJECT_PATCH_VERSION}${PROJECT_VERSION_EXTENSION}")

set(STRATOSHARK_MAJOR_VERSION 0)
set(STRATOSHARK_MINOR_VERSION 10)

set(STRATOSHARK_VERSION "${STRATOSHARK_MAJOR_VERSION}.${STRATOSHARK_MINOR_VERSION}.${PROJECT_PATCH_VERSION}${PROJECT_VERSION_EXTENSION}")

include( CMakeOptions.txt )

# We require minimum C11
set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)

# We require minimum C++11. libscap and libsinsp require C++ 17.
if(BUILD_stratoshark OR BUILD_falcodump OR BUILD_dumpcalls)
	set(CMAKE_CXX_STANDARD 17)
else()
	set(CMAKE_CXX_STANDARD 11)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

message(STATUS "Generating build using CMake ${CMAKE_VERSION}")

if(USE_MSYSTEM)
	# Prevent FindPython3.cmake from using the Python path in the registry,
	# only use the $PATH environment variable (which is set up for MSYS2).
	set(Python3_FIND_REGISTRY NEVER)
endif()
find_package(Python3 3.6 REQUIRED)

# Strawberry is a web browser away from being its own operating system. Find
# Perl before finding anything else so that we can avoid building with any of
# of Strawberry's components. Adding Strawberry's "/c" subdirectory to
# CMAKE_IGNORE_PREFIX_PATH should help us avoid pulling in libraries such as
# zlib and executables such as xsltproc. CMake 3.29.1 and later ignores their
# pkg-config: https://gitlab.kitware.com/cmake/cmake/-/merge_requests/9375
find_package(Perl)
if(WIN32 AND PERL_EXECUTABLE)
	string(TOLOWER ${PERL_EXECUTABLE} lower_perl)
	if (${lower_perl} MATCHES "^.:/strawberry/")
		string(REGEX REPLACE "^(.:/[^/]+).*" "\\1" strawberry_prefix ${PERL_EXECUTABLE})
		# CMAKE_IGNORE_PREFIX_PATH must be an exact installation prefix.
		list(APPEND CMAKE_IGNORE_PREFIX_PATH "${strawberry_prefix}/c")
		message(STATUS "Added ${strawberry_prefix}/c to CMAKE_IGNORE_PREFIX_PATH")
		unset(lower_perl)
		unset(strawberry_prefix)
	endif()
endif()


# Set a default build type if none was specified
set(_default_build_type "RelWithDebInfo")
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	set(CMAKE_BUILD_TYPE "${_default_build_type}" CACHE STRING "Choose the type of build." FORCE)
	# Set the possible values of build type for cmake-gui
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

# Build type is ignored by multi-config generators.
if (NOT CMAKE_CONFIGURATION_TYPES)
	message(STATUS "Using \"${CMAKE_GENERATOR}\" generator and build type \"${CMAKE_BUILD_TYPE}\"")
else()
	message(STATUS "Using \"${CMAKE_GENERATOR}\" generator (multi-config)")
endif()

#Where to find local cmake scripts
set(WS_CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
set(CMAKE_MODULE_PATH ${WS_CMAKE_MODULE_PATH})

# CMake >= 3.9.0 supports LTO/IPO.
if (ENABLE_LTO)
	include(CheckIPOSupported)
	check_ipo_supported(RESULT lto_supported OUTPUT lto_output)
	if(lto_supported)
		set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELEASE TRUE)
		message(STATUS "LTO/IPO is enabled for Release configuration")
	else()
		message(STATUS "LTO/IPO requested but it is not supported by the compiler: ${lto_output}")
	endif()
else()
	message(STATUS "LTO/IPO is not enabled")
endif()

# If our target platform is enforced by our generator, set
# WIRESHARK_TARGET_PLATFORM accordingly. Otherwise use
# %WIRESHARK_TARGET_PLATFORM%.

if(WIN32)
	if(DEFINED ENV{WIRESHARK_TARGET_PLATFORM})
		string(TOLOWER $ENV{WIRESHARK_TARGET_PLATFORM} _target_platform)
		set(WIRESHARK_TARGET_PLATFORM ${_target_platform})
	elseif(USE_MSYSTEM MATCHES "MINGW64|CLANG64|UCRT64")
		# https://www.msys2.org/docs/environments
		#    MSYS2 comes with different environments/subsystems and
		#    the first thing you have to decide is which one to use.
		#    The differences among the environments are mainly environment
		#    variables, default compilers/linkers, architecture,
		#    system libraries used etc. If you are unsure, go with UCRT64.
		set(WIRESHARK_TARGET_PLATFORM x64)
	elseif(USE_MSYSTEM)
		if($ENV{MSYSTEM_CARCH} MATCHES "x86_64")
			set(WIRESHARK_TARGET_PLATFORM x64)
		elseif($ENV{MSYSTEM_CARCH} MATCHES "i686")
			set(WIRESHARK_TARGET_PLATFORM win32)
		elseif($ENV{MSYSTEM_CARCH} MATCHES "aarch64")
			set(WIRESHARK_TARGET_PLATFORM "arm64")
		else()
			set(WIRESHARK_TARGET_PLATFORM "$ENV{MSYSTEM_CARCH}")
		endif()
	elseif($ENV{Platform} MATCHES arm64 OR CMAKE_GENERATOR_PLATFORM MATCHES arm64)
		set(WIRESHARK_TARGET_PLATFORM arm64)
	elseif(CMAKE_CL_64 OR CMAKE_GENERATOR MATCHES x64)
		set(WIRESHARK_TARGET_PLATFORM x64)
	else()
		message(WARNING "Assuming \"x64\" target platform")
		set(WIRESHARK_TARGET_PLATFORM x64)
	endif()

	if(WIRESHARK_TARGET_PLATFORM MATCHES "win32")
		message(FATAL_ERROR "Deprecated target platform ${WIRESHARK_TARGET_PLATFORM}. See https://gitlab.com/wireshark/wireshark/-/issues/17779 for details.")
	elseif(NOT (WIRESHARK_TARGET_PLATFORM MATCHES "x64" OR WIRESHARK_TARGET_PLATFORM MATCHES "arm64"))
		message(FATAL_ERROR "Invalid target platform: ${WIRESHARK_TARGET_PLATFORM}")
	endif()

	# Sanity check
	if(MSVC AND DEFINED ENV{PLATFORM})
		string(TOLOWER $ENV{PLATFORM} _vs_platform)
		if(
			(_vs_platform STREQUAL "x64" AND NOT WIRESHARK_TARGET_PLATFORM STREQUAL "x64")
			OR
			(_vs_platform STREQUAL "arm64" AND NOT WIRESHARK_TARGET_PLATFORM STREQUAL "arm64")
		)
			message(FATAL_ERROR "The PLATFORM environment variable (${_vs_platform})"
				" doesn't match the generator platform (${WIRESHARK_TARGET_PLATFORM})")
		endif()
	endif()

	message(STATUS
		"Building for ${WIRESHARK_TARGET_PLATFORM}"
	)

	if(NOT CMAKE_CROSSCOMPILING)
		find_package(PowerShell REQUIRED)
	endif()

	# Determine where the 3rd party libraries will be
	if(USE_REPOSITORY)
		if( DEFINED ENV{WIRESHARK_BASE_DIR} AND NOT WIRESHARK_BASE_DIR)
			set(WIRESHARK_BASE_DIR $ENV{WIRESHARK_BASE_DIR})
		endif()
		if(WIRESHARK_BASE_DIR)
			file( TO_CMAKE_PATH ${WIRESHARK_BASE_DIR} _ws_base_dir )
			set( _PROJECT_LIB_DIR "${_ws_base_dir}/wireshark-${WIRESHARK_TARGET_PLATFORM}-libs" )
			unset(_ws_base_dir)
		elseif( DEFINED ENV{WIRESHARK_LIB_DIR} )
			message(DEPRECATION "Support for the WIRESHARK_LIB_DIR environment variable will be removed in the future. Use WIRESHARK_BASE_DIR instead.")
			file( TO_CMAKE_PATH $ENV{WIRESHARK_LIB_DIR} _PROJECT_LIB_DIR )
		else()
			# Don't know what to do
			message(FATAL_ERROR "Neither WIRESHARK_BASE_DIR or WIRESHARK_LIB_DIR are defined")
		endif()

		include(FetchArtifacts)

		set(EXTRA_INSTALLER_DIR ${_PROJECT_LIB_DIR})

		# XXX Add a dependency on ${_ws_lib_dir}/current_tag.txt?
	else()
		set(EXTRA_INSTALLER_DIR ${CMAKE_BINARY_DIR}/packaging/nsis)
	endif()

	include(FetchContent)

	set(LIBS_URL "https://dev-libs.wireshark.org/windows/packages")
	file(TO_CMAKE_PATH ${EXTRA_INSTALLER_DIR} _file_download_dir)

	# Download Npcap required by the Windows installer.
	# We do this here and not in FetchArtifacts.cmake because this
	# is required by both the Visual Studio and MSYS2 builds.
	set(NPCAP_VERSION "1.83")
	set(NPCAP_SHA256 "1bf58936296992d6b03e6c36621ca8239a786c13b89d761d210fa21731567ac0")
	set(NPCAP_FILENAME "npcap-${NPCAP_VERSION}.exe")
	set(NPCAP_URL "${LIBS_URL}/Npcap/${NPCAP_FILENAME}")
	FetchContent_Declare(Npcap
		URL ${NPCAP_URL}
		DOWNLOAD_DIR ${_file_download_dir}
		URL_HASH SHA256=${NPCAP_SHA256}
		DOWNLOAD_NO_EXTRACT True
	)

	# Download USBPcap required by the Windows installer
	set(USBPCAP_VERSION "1.5.4.0")
	set(USBPCAP_SHA256 "87a7edf9bbbcf07b5f4373d9a192a6770d2ff3add7aa1e276e82e38582ccb622")
	set(USBPCAP_FILENAME "USBPcapSetup-${USBPCAP_VERSION}.exe")
	set(USBPCAP_URL "${LIBS_URL}/USBPcap/${USBPCAP_FILENAME}")
	FetchContent_Declare(USBPcap
		URL ${USBPCAP_URL}
		DOWNLOAD_DIR ${_file_download_dir}
		URL_HASH SHA256=${USBPCAP_SHA256}
		DOWNLOAD_NO_EXTRACT True
	)
endif(WIN32)

if(APPLE AND WIRESHARK_BASE_DIR)
	include(FetchArtifacts)
else()
	set(OSX_APP_LIBPREFIX "/usr/local")
endif()

include(UseCustomIncludes)
ADD_CUSTOM_CMAKE_INCLUDE()

# Ensure that all executables and libraries end up in the same directory. Actual
# files might end up in a configuration subdirectory, e.g. run/Debug or
# run/Release. We try to set DATAFILE_DIR to actual location below.
if(NOT ARCHIVE_OUTPUT_PATH)
	set(ARCHIVE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/run CACHE INTERNAL
		   "Single output directory for building all archives.")
endif()
if(NOT EXECUTABLE_OUTPUT_PATH)
	set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/run CACHE INTERNAL
		   "Single output directory for building all executables.")
endif()
if(NOT LIBRARY_OUTPUT_PATH)
	set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/run CACHE INTERNAL
		   "Single output directory for building all libraries.")
endif()

#
# The release mode (CMAKE_BUILD_TYPE=release) defines NDEBUG for
# the Unix Makefile generator.
#

# Defines CMAKE_INSTALL_BINDIR, CMAKE_INSTALL_DATADIR, etc ...
if(WIN32 AND NOT USE_MSYSTEM)
	# Override some values on Windows, to match the existing
	# convention of installing everything to a single root folder.
	set(CMAKE_INSTALL_BINDIR ".")
	set(CMAKE_INSTALL_LIBDIR ".")
	set(CMAKE_INSTALL_INCLUDEDIR "include")
	set(CMAKE_INSTALL_DATADIR ".")
	set(CMAKE_INSTALL_DOCDIR ".")
endif()
include(GNUInstallDirs)

set(PROJECT_INSTALL_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}")

# Make sure our executables can load our libraries if we install into
# a non-default directory on Unix-like systems other than macOS.
# https://gitlab.kitware.com/cmake/community/wikis/doc/cmake/RPATH-handling
set(LIBRARY_INSTALL_RPATH "${CMAKE_INSTALL_RPATH}")
set(EXECUTABLE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH}")
set(EXTCAP_INSTALL_RPATH "${CMAKE_INSTALL_RPATH}")
if(NOT (WIN32 OR APPLE OR USE_STATIC))
	# Try to set a RPATH for installed binaries if the library directory is
	# not already included in the default search list.
	list(FIND CMAKE_C_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_FULL_LIBDIR}" IS_SYSTEM_DIR)
	if(IS_SYSTEM_DIR EQUAL -1)
		# Some systems support $ORIGIN in RPATH to enable relocatable
		# binaries. In other cases, only absolute paths can be used.
		# https://www.lekensteyn.nl/rpath.html
		#
		# Also note that some systems (notably those using GNU libc)
		# silently ignore $ORIGIN in RPATH for binaries that are
		# setuid root or use privileged capabilities.
		#

=== epan/CMakeLists.txt ===
# CMakeLists.txt
#
# Wireshark - Network traffic analyzer
# By Gerald Combs <gerald@wireshark.org>
# Copyright 1998 Gerald Combs
#
# SPDX-License-Identifier: GPL-2.0-or-later
#

add_definitions(
		${LIBXML2_DEFINITIONS}
		${KERBEROS_DEFINITIONS}
)

add_subdirectory(crypt)
add_subdirectory(dfilter)
add_subdirectory(dissectors)
add_subdirectory(ftypes)

if(LUA_FOUND)
	add_subdirectory(wslua)
endif()

add_custom_command(
	OUTPUT ps.c
	COMMAND ${Python3_EXECUTABLE}
		${CMAKE_SOURCE_DIR}/tools/rdps.py
		${CMAKE_CURRENT_SOURCE_DIR}/print.ps
		ps.c
	DEPENDS
		${CMAKE_SOURCE_DIR}/tools/rdps.py
		${CMAKE_CURRENT_SOURCE_DIR}/print.ps
)

set(LIBWIRESHARK_PUBLIC_HEADERS
	addr_resolv.h
	address.h
	address_types.h
	aftypes.h
	arptypes.h
	asn1.h
	capture_dissectors.h
	charsets.h
	color_filters.h
	column.h
	column-info.h
	column-utils.h
	conversation.h
	conversation_debug.h
	conversation_table.h
	crc10-tvb.h
	crc16-tvb.h
	crc32-tvb.h
	crc6-tvb.h
	crc8-tvb.h
	decode_as.h
	disabled_protos.h
	conversation_filter.h
	dvb_chartbl.h
	epan.h
	epan_dissect.h
	etypes.h
	ex-opt.h
	except.h
	exceptions.h
	expert.h
	export_object.h
	exported_pdu.h
	fifo_string_cache.h
	filter_expressions.h
	aggregation_fields.h
	follow.h
	frame_data.h
	frame_data_sequence.h
	funnel.h
	#geoip_db.h
	golay.h
	guid-utils.h
	iana_charsets.h
	in_cksum.h
	introspection.h
	iana-ip.h
	ip_opts.h
	maxmind_db.h
	media_params.h
	next_tvb.h
	nghttp2_hd_huffman.h
	oids.h
	osi-utils.h
	oui.h
	packet.h
	packet_info.h
	params.h
	print.h
	print_stream.h
	prefs.h
	prefs-int.h
	proto.h
	proto_data.h
	ps.h
	ptvcursor.h
	range.h
	read_keytab_file.h
	reassemble.h
	reedsolomon.h
	register.h
	req_resp_hdrs.h
	rtd_table.h
	secrets.h
	show_exception.h
	sminmpec.h
	srt_table.h
	stat_tap_ui.h
	stat_groups.h
	stats_tree.h
	stats_tree_priv.h
	stream.h
	strutil.h
	t35.h
	tap.h
	tap-voip.h
	timestamp.h
	timestats.h
	tfs.h
	to_str.h
	tvbparse.h
	tvbuff.h
	tvbuff-int.h
	uat.h
	uat-int.h
	unit_strings.h
	uuid_types.h
	wmem_scopes.h
	wscbor.h
	wscbor_enc.h
)

set(LIBWIRESHARK_HEADER_FILES
	${LIBWIRESHARK_PUBLIC_HEADERS}
)

set(LIBWIRESHARK_NONGENERATED_FILES
	addr_resolv.c
	address_types.c
	aftypes.c
	asn1.c
	capture_dissectors.c
	charsets.c
	color_filters.c
	column.c
	column-utils.c
	conversation.c
	conversation_table.c
	crc10-tvb.c
	crc16-tvb.c
	crc32-tvb.c
	crc6-tvb.c
	crc8-tvb.c
	decode_as.c
	disabled_protos.c
	conversation_filter.c
	dvb_chartbl.c
	enterprises.c
	epan.c
	ex-opt.c
	except.c
	expert.c
	export_object.c
	exported_pdu.c
	fifo_string_cache.c
	filter_expressions.c
	aggregation_fields.c
	follow.c
	frame_data.c
	frame_data_sequence.c
	funnel.c
	#geoip_db.c
	golay.c
	guid-utils.c
	iana_charsets.c
	iana-ip.c
	in_cksum.c
	introspection.c
	manuf.c
	maxmind_db.c
	media_params.c
	next_tvb.c
	nghttp2_hd_huffman_data.c
	oids.c
	osi-utils.c
	packet.c
	print.c
	print_stream.c
	prefs.c
	proto.c
	proto_data.c
	range.c
	read_keytab_file.c
	reassemble.c
	reedsolomon.c
	register.c
	req_resp_hdrs.c
	rtd_table.c
	secrets.c
	sequence_analysis.c
	services.c
	show_exception.c
	srt_table.c
	stat_tap_ui.c
	stats_tree.c
	strutil.c
	stream.c
	t35.c
	tap.c
	timestamp.c
	timestats.c
	tfs.c
	to_str.c
	tvbparse.c
	tvbuff.c
	tvbuff_base64.c
	tvbuff_brotli.c
	tvbuff_snappy.c
	tvbuff_composite.c
	tvbuff_hpackhuff.c
	tvbuff_real.c
	tvbuff_subset.c
	tvbuff_zlib.c
	tvbuff_zstd.c
	tvbuff_lz77.c
	tvbuff_lz77huff.c
	tvbuff_lznt1.c
	tvbuff_rdp.c
	uat.c
	uuid_types.c
	wscbor.c
	wscbor_enc.c
	unit_strings.c
	wmem_scopes.c
	protobuf-helper.c
	protobuf_lang_tree.c
	${CMAKE_CURRENT_BINARY_DIR}/ps.c
)

set(LIBWIRESHARK_FILES ${LIBWIRESHARK_NONGENERATED_FILES})

add_lex_files(LEX_FILES LIBWIRESHARK_FILES
	uat_load.l
	protobuf_lang_scanner.l
)

add_lemon_files(LEMON_FILES LIBWIRESHARK_FILES
	protobuf_lang_parser.lemon
)

set_source_files_properties(
	${LIBWIRESHARK_NONGENERATED_FILES}
	PROPERTIES
	COMPILE_FLAGS "${WERROR_COMMON_FLAGS}"
)

add_library(epan
	#Included so that Visual Studio can properly put header files in solution
	${LIBWIRESHARK_HEADER_FILES}

	${LIBWIRESHARK_FILES}
	$<TARGET_OBJECTS:crypt>
	$<TARGET_OBJECTS:dfilter>
	$<TARGET_OBJECTS:dissectors>
	$<TARGET_OBJECTS:dissectors-corba>
	$<TARGET_OBJECTS:dissector-registration>
	$<TARGET_OBJECTS:ftypes>
	$<$<BOOL:${LUA_FOUND}>:$<TARGET_OBJECTS:wslua>>
	${CMAKE_BINARY_DIR}/resources/libwireshark.rc
)

set_target_properties(epan PROPERTIES
	COMPILE_DEFINITIONS "WS_BUILD_DLL"
	LINK_FLAGS "${WS_LINK_FLAGS}"
	VERSION "0.0.0" SOVERSION 0
	INSTALL_RPATH "${LIBRARY_INSTALL_RPATH}"
	# By default the name for a library with target name epan will be libepan,
	# but Ethereal is now named Wireshark
	OUTPUT_NAME "wireshark"
	PREFIX "lib"
	FOLDER "DLLs"
)
if(MSVC)
	set_target_properties(epan PROPERTIES LINK_FLAGS_DEBUG "${WS_MSVC_DEBUG_LINK_FLAGS}")
endif()

target_link_libraries(epan
	PUBLIC
		wsutil
		${GLIB2_LIBRARIES}
	PRIVATE
		wiretap
		${BROTLI_LIBRARIES}
		${CARES_LIBRARIES}
		${GCRYPT_LIBRARIES}
		${GIO2_LIBRARIES}
		${GNUTLS_LIBRARIES}
		${KERBEROS_LIBRARIES}
		${LIBXML2_LIBRARIES}
		${LUA_LIBRARIES}
		${LZ4_LIBRARIES}
		${M_LIBRARIES}
		${NGHTTP2_LIBRARIES}
		${NGHTTP3_LIBRARIES}
		${SMI_LIBRARIES}
		${SNAPPY_LIBRARIES}
		${WIN_WS2_32_LIBRARY}
		${XXHASH_LIBRARIES}
		${ZLIB_LIBRARIES}
		${ZLIBNG_LIBRARIES}
		${ZSTD_LIBRARIES}
		$<$<BOOL:${LUA_FOUND}>:lrexlib>
)

target_include_directories(epan
	SYSTEM PUBLIC
		${GLIB2_INCLUDE_DIRS}
)

target_include_directories(epan
	INTERFACE
		$<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}>
		$<INSTALL_INTERFACE:include/wireshark>
)

target_include_directories(epan
	SYSTEM PRIVATE
		${BROTLI_INCLUDE_DIRS}
		${CARES_INCLUDE_DIRS}
		${GCRYPT_INCLUDE_DIRS}
		${KERBEROS_INCLUDE_DIRS}
		${GLIB2_INCLUDE_DIRS}
		${GNUTLS_INCLUDE_DIRS}
		${LIBXML2_INCLUDE_DIRS}
		${LUA_INCLUDE_DIRS}
		${LZ4_INCLUDE_DIRS}
		${NGHTTP2_INCLUDE_DIRS}
		${NGHTTP3_INCLUDE_DIRS}
		${SMI_INCLUDE_DIRS}
		${SNAPPY_INCLUDE_DIRS}
		${ZLIB_INCLUDE_DIRS}
		${ZLIBNG_INCLUDE_DIRS}
		${ZSTD_INCLUDE_DIRS}
	PRIVATE
		${CMAKE_CURRENT_BINARY_DIR}
		${CMAKE_CURRENT_SOURCE_DIR}
)

add_dependencies(epan lemon)

install(TARGETS epan
	EXPORT WiresharkTargets
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES ${LIBWIRESHARK_PUBLIC_HEADERS}
	DESTINATION "${PROJECT_INSTALL_INCLUDEDIR}/epan"
	COMPONENT "Development"
	EXCLUDE_FROM_ALL
)

add_executable(exntest EXCLUDE_FROM_ALL exntest.c except.c)
target_link_libraries(exntest epan)
set_target_properties(exntest PROPERTIES
	FOLDER "Tests"
	EXCLUDE_FROM_DEFAULT_BUILD True
	COMPILE_DEFINITIONS "WS_BUILD_DLL"
	COMPILE_FLAGS "${WERROR_COMMON_FLAGS}"
)

add_executable(fifo_string_cache_test EXCLUDE_FROM_ALL fifo_string_cache_test.c)
target_link_libraries(fifo_string_cache_test epan)
set_target_properties(fifo_string_cache_test PROPERTIES
	FOLDER "Tests"
	EXCLUDE_FROM_DEFAULT_BUILD True
	COMPILE_DEFINITIONS "WS_BUILD_DLL"
	COMPILE_FLAGS "${WERROR_COMMON_FLAGS}"
)

add_executable(oids_test EXCLUDE_FROM_ALL oids_test.c)
target_link_libraries(oids_test epan)
set_target_properties(oids_test PROPERTIES
	FOLDER "Tests"
	EXCLUDE_FROM_DEFAULT_BUILD True
	COMPILE_DEFINITIONS "WS_BUILD_DLL"
	COMPILE_FLAGS "${WERROR_COMMON_FLAGS}"
)

add_executable(reassemble_test EXCLUDE_FROM_ALL reassemble_test.c)
target_link_libraries(reassemble_test epan)
set_target_properties(reassemble_test PROPERTIES
	FOLDER "Tests"
	EXCLUDE_FROM_DEFAULT_BUILD True
	COMPILE_FLAGS "${WERROR_COMMON_FLAGS}"
)

add_executable(tvbtest EXCLUDE_FROM_ALL tvbtest.c)
target_link_libraries(tvbtest epan)
set_target_properties(tvbtest PROPERTIES
	FOLDER "Tests"
	EXCLUDE_FROM_DEFAULT_BUILD True
	COMPILE_DEFINITIONS "WS_BUILD_DLL"
	COMPILE_FLAGS "${WERROR_COMMON_FLAGS}"
)

add_executable(wscbor_test EXCLUDE_FROM_ALL wscbor_test.c)
target_link_libraries(wscbor_test epan)
set_target_properties(wscbor_test PROPERTIES
    FOLDER "Tests"
    EXCLUDE_FROM_DEFAULT_BUILD True
    COMPILE_FLAGS "${WERROR_COMMON_FLAGS}"
)

add_executable(wscbor_enc_test EXCLUDE_FROM_ALL wscbor_enc_test.c)
target_link_libraries(wscbor_enc_test epan)
set_target_properties(wscbor_enc_test PROPERTIES
    FOLDER "Tests"
    EXCLUDE_FROM_DEFAULT_BUILD True
    COMPILE_FLAGS "${WERROR_COMMON_FLAGS}"
)

add_executable(test_epan EXCLUDE_FROM_ALL test_epan.c)
target_link_libraries(test_epan epan)
set_target_properties(test_epan PROPERTIES
	FOLDER "Tests"
	EXCLUDE_FROM_DEFAULT_BUILD True
	COMPILE_FLAGS "${WERROR_COMMON_FLAGS}"
)

CHECKAPI(
	NAME
	  epan
	SWITCHES
	SOURCES
	  ${LIBWIRESHARK_NONGENERATED_FILES}
)

#
# Editor modelines  -  https://www.wireshark.org/tools/modelines.html
#
# Local variables:
# c-basic-offset: 8
# tab-width: 8
# indent-tabs-mode: t
# End:
#
# vi: set shiftwidth=8 tabstop=8 noexpandtab:
# :indentSize=8:tabSize=8:noTabs=false:
#

=== extcap/CMakeLists.txt ===
# CMakeLists.txt
#
# Wireshark - Network traffic analyzer
# By Gerald Combs <gerald@wireshark.org>
# Copyright 1998 Gerald Combs
#
# SPDX-License-Identifier: GPL-2.0-or-later
#

if(EXTCAP_ANDROIDDUMP_LIBPCAP)
	set(ANDROIDDUMP_USE_LIBPCAP 1)
endif()

if(LIBSSH_FOUND)
	include(CMakePushCheckState)
	cmake_push_check_state()
	set(CMAKE_REQUIRED_INCLUDES ${LIBSSH_INCLUDE_DIRS})
	set(CMAKE_REQUIRED_LIBRARIES ${LIBSSH_LIBRARIES})
	check_function_exists(ssh_userauth_agent LIBSSH_USERAUTH_AGENT_FOUND)
	cmake_pop_check_state()
endif()

# Ensure "run/extcap" exists
# add_custom_command(OUTPUT "${DATAFILE_DIR}/extcap"
# 	COMMAND ${CMAKE_COMMAND} -E make_directory
# 		"${DATAFILE_DIR}/extcap"
# )
# list(APPEND copy_data_files_depends "${DATAFILE_DIR}/extcap")

macro(set_common_executable_properties _executable _application)
	set_target_properties(${_executable} PROPERTIES
		LINK_FLAGS "${WS_LINK_FLAGS}"
		FOLDER "Executables/Extcaps"
		INSTALL_RPATH "${EXTCAP_INSTALL_RPATH}"
	)
	if(MSVC)
		set_target_properties(${_executable} PROPERTIES LINK_FLAGS_DEBUG "${WS_MSVC_DEBUG_LINK_FLAGS}")
	endif()

	set(PROGLIST ${PROGLIST} ${_executable})

	string(TOLOWER ${_application} _application_lower)
	if(CMAKE_CONFIGURATION_TYPES)
		set_target_properties(${_executable} PROPERTIES
			RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/run/extcap/${_application_lower}
			RUNTIME_OUTPUT_DIRECTORY_DEBUG ${CMAKE_BINARY_DIR}/run/Debug/extcap/${_application_lower}
			RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_BINARY_DIR}/run/Release/extcap/${_application_lower}
			RUNTIME_OUTPUT_DIRECTORY_MINSIZEREL ${CMAKE_BINARY_DIR}/run/MinSizeRel/extcap/${_application_lower}
			RUNTIME_OUTPUT_DIRECTORY_RELWITHDEBINFO ${CMAKE_BINARY_DIR}/run/RelWithDebInfo/extcap/${_application_lower}
		)
	else()
		set_target_properties(${_executable} PROPERTIES
			RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/run/extcap/${_application_lower}
		)
		if(ENABLE_APPLICATION_BUNDLE)
			if(NOT CMAKE_CFG_INTDIR STREQUAL ".")
				# Xcode
				set_target_properties(${_executable} PROPERTIES
					RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/run/$<CONFIG>/${_application}.app/Contents/MacOS/extcap
				)
			else()
				set_target_properties(${_executable} PROPERTIES
					RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/run/${_application}.app/Contents/MacOS/extcap
				)
				# Create a convenience link from run/<name> to its respective
				# target in the application bundle.
				add_custom_target(${_executable}-symlink
					COMMAND ln -s -f
						${_application}.app/Contents/MacOS/extcap/${_executable}
						${CMAKE_BINARY_DIR}/run/${_executable}
				)
				add_dependencies(${_executable} ${_executable}-symlink)
			endif()
		endif()
	endif()

	if (MINGW)
		set_target_properties(${_executable} PROPERTIES
			LINK_OPTIONS -municode
		)
	endif()

	unset(_application_lower)
endmacro()

macro(set_extcap_executable_properties _executable)
	set_common_executable_properties(${_executable} Wireshark)
endmacro()

macro(set_extlog_executable_properties _executable)
	set_common_executable_properties(${_executable} Stratoshark)
endmacro()

add_custom_target(extcaps)

add_library(extcap-base OBJECT extcap-base.c)
if(LIBSSH_FOUND)
	add_library(ssh-base OBJECT ssh-base.c)
	target_include_directories(ssh-base SYSTEM
		PRIVATE
			${LIBSSH_INCLUDE_DIRS}
	)
endif()

if(BUILD_androiddump)
	if(EXTCAP_ANDROIDDUMP_LIBPCAP)
		if(HAVE_LIBPCAP)
			set(androiddump_LIBS
				ui
				wiretap
				wsutil
				${WIN_WS2_32_LIBRARY}
				$<$<BOOL:${PCAP_FOUND}>:pcap::pcap>
			)
		else()
			message(FATAL_ERROR "You are trying to build androiddump with libpcap but do not have it")
		endif()
	else()
		set(androiddump_LIBS
			ui
			wiretap
			wsutil
			${CMAKE_DL_LIBS}
			${WIN_WS2_32_LIBRARY}
		)
	endif()
	set(androiddump_FILES
		$<TARGET_OBJECTS:cli_main>
		$<TARGET_OBJECTS:extcap-base>
		androiddump.c
		../app/wireshark_flavor.c
	)

	set_executable_resources(androiddump "Androiddump")
	add_executable(androiddump ${androiddump_FILES})
	set_extcap_executable_properties(androiddump)
	target_link_libraries(androiddump ${androiddump_LIBS})
	install(TARGETS androiddump RUNTIME DESTINATION ${EXTCAP_INSTALL_LIBDIR})
	add_dependencies(extcaps androiddump)
endif()

if(BUILD_sshdump AND LIBSSH_FOUND)
	set(sshdump_LIBS
		wsutil
		${CMAKE_DL_LIBS}
		${WIN_WS2_32_LIBRARY}
		${LIBSSH_LIBRARIES}
	)
	set(sshdump_FILES
		$<TARGET_OBJECTS:cli_main>
		$<TARGET_OBJECTS:extcap-base>
		$<TARGET_OBJECTS:ssh-base>
		sshdump.c
		../app/wireshark_flavor.c
	)

	set_executable_resources(sshdump "Sshdump")
	add_executable(sshdump ${sshdump_FILES})
	set_extcap_executable_properties(sshdump)
	target_link_libraries(sshdump ${sshdump_LIBS})
	target_include_directories(sshdump SYSTEM PRIVATE ${LIBSSH_INCLUDE_DIRS})
	install(TARGETS sshdump RUNTIME DESTINATION ${EXTCAP_INSTALL_LIBDIR})
	add_dependencies(extcaps sshdump)
elseif (BUILD_sshdump)
	#message( WARNING "Cannot find libssh, cannot build sshdump" )
endif()

if(BUILD_ciscodump AND LIBSSH_FOUND)
	set(ciscodump_LIBS
		writecap
		wsutil
		${CMAKE_DL_LIBS}
		${WIN_WS2_32_LIBRARY}
		${LIBSSH_LIBRARIES}
	)
	set(ciscodump_FILES
		$<TARGET_OBJECTS:cli_main>
		$<TARGET_OBJECTS:extcap-base>
		$<TARGET_OBJECTS:ssh-base>
		ciscodump.c
		../app/wireshark_flavor.c
	)

	set_executable_resources(ciscodump "Ciscodump")
	add_executable(ciscodump ${ciscodump_FILES})
	set_extcap_executable_properties(ciscodump)
	target_link_libraries(ciscodump ${ciscodump_LIBS})
	target_include_directories(ciscodump SYSTEM PRIVATE ${LIBSSH_INCLUDE_DIRS})
	install(TARGETS ciscodump RUNTIME DESTINATION ${EXTCAP_INSTALL_LIBDIR})
	add_dependencies(extcaps ciscodump)
elseif (BUILD_ciscodump)
	#message( WARNING "Cannot find libssh, cannot build ciscodump" )
endif()

if(BUILD_wifidump AND LIBSSH_FOUND)
	set(wifidump_LIBS
		writecap
		wsutil
		${CMAKE_DL_LIBS}
		${WIN_WS2_32_LIBRARY}
		${LIBSSH_LIBRARIES}
	)
	set(wifidump_FILES
		$<TARGET_OBJECTS:cli_main>
		$<TARGET_OBJECTS:extcap-base>
		$<TARGET_OBJECTS:ssh-base>
		wifidump.c
		../app/wireshark_flavor.c
	)

	set_executable_resources(wifidump "Wifidump")
	add_executable(wifidump ${wifidump_FILES})
	set_extcap_executable_properties(wifidump)
	target_link_libraries(wifidump ${wifidump_LIBS})
	target_include_directories(wifidump SYSTEM PRIVATE ${LIBSSH_INCLUDE_DIRS})
	install(TARGETS wifidump RUNTIME DESTINATION ${EXTCAP_INSTALL_LIBDIR})
	add_dependencies(extcaps wifidump)
elseif (BUILD_wifidump)
	#message( WARNING "Cannot find libssh, cannot build wifidump" )
endif()

if(BUILD_dpauxmon AND HAVE_LIBNL3)
	set(dpauxmon_LIBS
		wsutil
		writecap
		${GLIB2_LIBRARIES}
		${CMAKE_DL_LIBS}
		${NL_LIBRARIES}
	)
	set(dpauxmon_FILES
		$<TARGET_OBJECTS:extcap-base>
		dpauxmon.c
	)

	set_executable_resources(dpauxmon "dpauxmon")
	add_executable(dpauxmon ${dpauxmon_FILES})
	set_extcap_executable_properties(dpauxmon)
	target_link_libraries(dpauxmon ${dpauxmon_LIBS})
	target_include_directories(dpauxmon SYSTEM PRIVATE ${NL_INCLUDE_DIRS})
	install(TARGETS dpauxmon RUNTIME DESTINATION ${EXTCAP_INSTALL_LIBDIR})
	add_dependencies(extcaps dpauxmon)
elseif (BUILD_dpauxmon)
	#message( WARNING "Cannot find libnl3, cannot build dpauxmon" )
endif()

if(BUILD_udpdump)
	set(udpdump_LIBS
		wsutil
		${CMAKE_DL_LIBS}
		${WIN_WS2_32_LIBRARY}
		wsutil
		writecap
	)
	set(udpdump_FILES
		$<TARGET_OBJECTS:cli_main>
		$<TARGET_OBJECTS:extcap-base>
		udpdump.c
		../app/wireshark_flavor.c
	)

	set_executable_resources(udpdump "udpdump")
	add_executable(udpdump ${udpdump_FILES})
	set_extcap_executable_properties(udpdump)
	target_link_libraries(udpdump ${udpdump_LIBS})
	install(TARGETS udpdump RUNTIME DESTINATION ${EXTCAP_INSTALL_LIBDIR})
	add_dependencies(extcaps udpdump)
endif()

if(BUILD_randpktdump)
	set(randpktdump_LIBS
		randpkt_core
		wiretap
		wsutil
		${CMAKE_DL_LIBS}
		${WIN_WS2_32_LIBRARY}
	)
	set(randpktdump_FILES
		$<TARGET_OBJECTS:cli_main>
		$<TARGET_OBJECTS:extcap-base>
		randpktdump.c
		../app/wireshark_flavor.c
	)

	set_executable_resources(randpktdump "randpktdump")
	add_executable(randpktdump ${randpktdump_FILES})
	set_extcap_executable_properties(randpktdump)
	target_link_libraries(randpktdump ${randpktdump_LIBS})
	install(TARGETS randpktdump RUNTIME DESTINATION ${EXTCAP_INSTALL_LIBDIR})
	add_dependencies(extcaps randpktdump)
endif()


if(BUILD_etwdump AND WIN32)
	set(etwdump_LIBS
		wiretap
		wsutil
		tdh
		wevtapi
		rpcrt4
		${CMAKE_DL_LIBS}
		${WIN_WS2_32_LIBRARY}
	)
	set(etwdump_FILES
		$<TARGET_OBJECTS:cli_main>
		$<TARGET_OBJECTS:extcap-base>
		etwdump.c
		etl.c
		etw_message.c
		etw_ndiscap.c
		../app/wireshark_flavor.c
	)

	set_executable_resources(etwdump "etwdump")
	add_executable(etwdump ${etwdump_FILES})
	set_extcap_executable_properties(etwdump)
	target_link_libraries(etwdump ${etwdump_LIBS})
	install(TARGETS etwdump RUNTIME DESTINATION ${EXTCAP_INSTALL_LIBDIR})
	add_dependencies(extcaps etwdump)
endif()

if(BUILD_sdjournal AND SYSTEMD_FOUND)
	set(sdjournal_LIBS
		writecap
		wsutil
		${CMAKE_DL_LIBS}
		${SYSTEMD_LIBRARIES}
	)
	set(sdjournal_FILES
		$<TARGET_OBJECTS:extcap-base>
		sdjournal.c
		../app/wireshark_flavor.c
	)

	set_executable_resources(sdjournal "sdjournal")
	add_executable(sdjournal ${sdjournal_FILES})
	set_extcap_executable_properties(sdjournal)
	target_link_libraries(sdjournal ${sdjournal_LIBS})
	target_include_directories(sdjournal SYSTEM PRIVATE ${SYSTEMD_INCLUDE_DIRS})
	install(TARGETS sdjournal RUNTIME DESTINATION ${EXTCAP_INSTALL_LIBDIR})
	add_dependencies(extcaps sdjournal)
endif()

if(BUILD_dumpcalls AND SINSP_FOUND)
	set(dumpcalls_LIBS
		wsutil
		${SINSP_LINK_LIBRARIES}
		${CMAKE_DL_LIBS}
		${GCRYPT_LIBRARIES}
	)
	set(dumpcalls_FILES
		$<TARGET_OBJECTS:extcap-base>
		dumpcalls.cpp
		../app/stratoshark_flavor.c
	)

	set_executable_resources(dumpcalls "dumpcalls")
	add_executable(dumpcalls ${dumpcalls_FILES})
	set_extlog_executable_properties(dumpcalls)
	target_link_libraries(dumpcalls ${dumpcalls_LIBS})
	target_include_directories(dumpcalls SYSTEM PRIVATE ${SINSP_INCLUDE_DIRS})
	if(WIN32)
		# libsinsp/dumper.h includes libscap/scap_savefile_api.h, which includes
		# libscap/scap_zlib.h.
		target_include_directories(dumpcalls SYSTEM PRIVATE ${ZLIB_INCLUDE_DIR})
	endif()
	install(TARGETS dumpcalls RUNTIME DESTINATION ${STRATOSHARK_EXTCAP_INSTALL_LIBDIR})
	add_dependencies(extcaps dumpcalls)
endif()

if(BUILD_falcodump AND SINSP_FOUND)
	set(falcodump_LIBS
		wsutil
		${SINSP_LINK_LIBRARIES}
		${CMAKE_DL_LIBS}
		${GCRYPT_LIBRARIES}
	)
	set(falcodump_FILES
		$<TARGET_OBJECTS:extcap-base>
		falcodump.cpp
		../app/stratoshark_flavor.c
	)

	set_executable_resources(falcodump "falcodump")
	add_executable(falcodump ${falcodump_FILES})
	set_extlog_executable_properties(falcodump)
	target_link_libraries(falcodump ${falcodump_LIBS})
	target_include_directories(falcodump SYSTEM PRIVATE ${SINSP_INCLUDE_DIRS})
	if(WIN32)
		# libsinsp/dumper.h includes libscap/scap_savefile_api.h, which includes
		# libscap/scap_zlib.h.
		target_include_directories(falcodump SYSTEM PRIVATE ${ZLIB_INCLUDE_DIR})
	endif()
	install(TARGETS falcodump RUNTIME DESTINATION ${STRATOSHARK_EXTCAP_INSTALL_LIBDIR})
	add_dependencies(extcaps falcodump)
endif()

if(BUILD_sshdig AND LIBSSH_FOUND)
	set(sshdig_LIBS
		wsutil
		${CMAKE_DL_LIBS}
		${WIN_WS2_32_LIBRARY}
		${LIBSSH_LIBRARIES}
	)
	set(sshdig_FILES
		$<TARGET_OBJECTS:cli_main>
		$<TARGET_OBJECTS:extcap-base>
		$<TARGET_OBJECTS:ssh-base>
		sshdig.c
		../app/stratoshark_flavor.c
	)

	set_executable_resources(sshdig "Sshdig")
	add_executable(sshdig ${sshdig_FILES})
	set_extlog_executable_properties(sshdig)
	target_link_libraries(sshdig ${sshdig_LIBS})
	target_include_directories(sshdig SYSTEM PRIVATE ${LIBSSH_INCLUDE_DIRS})
	install(TARGETS sshdig RUNTIME DESTINATION ${EXTCAP_INSTALL_LIBDIR})
	add_dependencies(extcaps sshdig)
elseif (BUILD_sshdig)
	#message( WARNING "Cannot find libssh, cannot build sshdig" )
endif()

#
# Editor modelines  -  https://www.wireshark.org/tools/modelines.html
#
# Local variables:
# c-basic-offset: 8
# tab-width: 8

=== ui/qt/CMakeLists.txt ===
# CMakeLists.txt
#
# Wireshark - Network traffic analyzer
# By Gerald Combs <gerald@wireshark.org>
# Copyright 1998 Gerald Combs
#
# SPDX-License-Identifier: GPL-2.0-or-later
#

if(USE_qt6)
	set(qtver "6")
else()
	set(qtver "5")
endif()

ADD_CUSTOM_CMAKE_INCLUDE()

set(WIRESHARK_WIDGET_HEADERS
	widgets/additional_toolbar.h
	widgets/apply_line_edit.h
	widgets/base_data_source_view.h
	widgets/capture_filter_combo.h
	widgets/capture_filter_edit.h
	widgets/clickable_label.h
	widgets/compression_group_box.h
	widgets/copy_from_profile_button.h
	widgets/detachable_tabwidget.h
	widgets/display_filter_combo.h
	widgets/display_filter_edit.h
	widgets/dissector_syntax_line_edit.h
	widgets/dissector_tables_view.h
	widgets/drag_drop_toolbar.h
	widgets/drag_label.h
	widgets/editor_file_dialog.h
	widgets/elided_label.h
	widgets/expert_info_view.h
	widgets/export_objects_view.h
	widgets/field_filter_edit.h
	widgets/filter_expression_toolbar.h
	widgets/find_line_edit.h
	widgets/follow_stream_text.h
	widgets/hex_data_source_view.h
	widgets/interface_toolbar_lineedit.h
	widgets/json_data_source_view.h
	widgets/label_stack.h
	widgets/overlay_scroll_bar.h
	widgets/packet_list_header.h
	widgets/path_selection_edit.h
	widgets/pref_module_view.h
	widgets/profile_tree_view.h
	widgets/qcp_axis_ticker_elided.h
	widgets/qcp_axis_ticker_si.h
	widgets/qcp_spacer_legend_item.h
	widgets/qcp_string_legend_item.h
	widgets/range_syntax_lineedit.h
	widgets/resize_header_view.h
	widgets/resolved_addresses_view.h
	widgets/rowmove_tree_view.h
	widgets/rtp_audio_graph.h
	widgets/splash_overlay.h
	widgets/stock_icon_tool_button.h
	widgets/syntax_line_edit.h
	widgets/tabnav_tree_view.h
	widgets/traffic_tab.h
	widgets/traffic_tree.h
	widgets/traffic_types_list.h
	widgets/wireless_timeline.h
	widgets/wireshark_file_dialog.h
	widgets/customplot.h
)

set(WIRESHARK_3RD_PARTY_WIDGET_HEADERS
	widgets/qcustomplot.h
)

set(WIRESHARK_MANAGER_HEADERS
	manager/preference_manager.h
	manager/wireshark_preference.h
)

set(WIRESHARK_UTILS_HEADERS
	utils/color_utils.h
	utils/data_printer.h
	utils/field_information.h
	utils/frame_information.h
	utils/idata_printable.h
	utils/profile_switcher.h
	utils/proto_node.h
	utils/qt_ui_utils.h
	utils/rtp_audio_file.h
	utils/rtp_audio_routing_filter.h
	utils/rtp_audio_routing.h
	utils/rtp_audio_silence_generator.h
	utils/stock_icon.h
	utils/tango_colors.h
	utils/variant_pointer.h
	utils/wireshark_mime_data.h
	utils/wireshark_zip_helper.h
)

set(WIRESHARK_MODEL_HEADERS
	models/astringlist_list_model.h
	models/atap_data_model.h
	models/cache_proxy_model.h
	models/coloring_rules_delegate.h
	models/coloring_rules_model.h
	models/column_list_model.h
	models/credentials_model.h
	models/decode_as_delegate.h
	models/decode_as_model.h
	models/dissector_tables_model.h
	models/enabled_protocols_model.h
	models/expert_info_model.h
	models/expert_info_proxy_model.h
	models/export_objects_model.h
	models/fileset_entry_model.h
	models/filter_list_model.h
	models/info_proxy_model.h
	models/interface_sort_filter_model.h
	models/interface_tree_cache_model.h
	models/interface_tree_model.h
	models/manuf_table_model.h
	models/numeric_value_chooser_delegate.h
	models/packet_list_model.h
	models/packet_list_record.h
	models/path_selection_delegate.h
	models/percent_bar_delegate.h
	models/pref_delegate.h
	models/pref_models.h
	models/profile_model.h
	models/proto_tree_model.h
	models/related_packet_delegate.h
	models/resolved_addresses_models.h
	models/sparkline_delegate.h
	models/supported_protocols_model.h
	models/timeline_delegate.h
	models/tree_model_helpers.h
	models/uat_delegate.h
	models/uat_model.h
	models/url_link_delegate.h
	models/voip_calls_info_model.h
)

# All .h files which inherit from QObject aka which use the Q_OBJECT macro
# need to go here.
set(WIRESHARK_QT_HEADERS
	about_dialog.h
	accordion_frame.h
	address_editor_frame.h
	bluetooth_att_server_attributes_dialog.h
	bluetooth_device_dialog.h
	bluetooth_devices_dialog.h
	bluetooth_hci_summary_dialog.h
	capture_comment_dialog.h
	capture_file_dialog.h
	capture_file_properties_dialog.h
	capture_file.h
	capture_filter_syntax_worker.h
	capture_options_dialog.h
	capture_preferences_frame.h
	coloring_rules_dialog.h
	column_editor_frame.h
	column_preferences_frame.h
	compiled_filter_output.h
	conversation_colorize_action.h
	conversation_dialog.h
	conversation_hash_tables_dialog.h
	credentials_dialog.h
	data_source_tab.h
	decode_as_dialog.h
	display_filter_expression_dialog.h
	dissector_tables_dialog.h
	enabled_protocols_dialog.h
	endpoint_dialog.h
	expert_info_dialog.h
	export_dissection_dialog.h
	export_object_action.h
	export_object_dialog.h
	export_pdu_dialog.h
	extcap_argument_file.h
	extcap_argument_multiselect.h
	extcap_argument.h
	extcap_options_dialog.h
	file_set_dialog.h
	filter_action.h
	filter_dialog.h
	filter_expression_frame.h
	firewall_rules_dialog.h
	follow_stream_action.h
	follow_stream_dialog.h
	font_color_preferences_frame.h
	funnel_statistics.h
	funnel_string_dialog.h
	funnel_text_dialog.h
	geometry_state_dialog.h
	glib_mainloop_on_qeventloop.h
	graph.h
	gsm_map_summary_dialog.h
	iax2_analysis_dialog.h
	import_text_dialog.h
	interface_frame.h
	interface_toolbar_reader.h
	interface_toolbar.h
	keyboard_shortcuts_dialog.h
	io_console_dialog.h
	io_graph.h
	io_graph_action.h
	io_graph_dialog.h
	layout_preferences_frame.h
	lbm_lbtrm_transport_dialog.h
	lbm_lbtru_transport_dialog.h
	lbm_stream_dialog.h
	lte_mac_statistics_dialog.h
	lte_rlc_graph_dialog.h
	lte_rlc_statistics_dialog.h
	main_application.h
	main_status_bar.h
	main_window_preferences_frame.h
	main_window.h
	manage_interfaces_dialog.h
	manuf_dialog.h
	module_preferences_scroll_area.h
	mtp3_summary_dialog.h
	multicast_statistics_dialog.h
	packet_comment_dialog.h
	packet_diagram.h
	packet_dialog.h
	packet_format_group_box.h
	packet_format_stack.h
	packet_list.h
	packet_range_group_box.h
	plot.h
	plot_action.h
	plot_dialog.h
	marker_dialog.h
	preference_editor_frame.h
	preferences_dialog.h
	print_dialog.h
	profile_dialog.h
	progress_frame.h
	proto_tree.h
	protocol_hierarchy_dialog.h
	protocol_preferences_menu.h
	recent_file_status.h
	resolved_addresses_dialog.h
	response_time_delay_dialog.h
	rpc_service_response_time_dialog.h
	rsa_keys_frame.h
	rtp_analysis_dialog.h
	rtp_audio_stream.h
	rtp_player_dialog.h
	rtp_stream_dialog.h
	scsi_service_response_time_dialog.h
	sctp_all_assocs_dialog.h
	sctp_assoc_analyse_dialog.h
	sctp_chunk_statistics_dialog.h
	sctp_graph_arwnd_dialog.h
	sctp_graph_byte_dialog.h
	sctp_graph_dialog.h
	search_frame.h
	sequence_diagram.h
	sequence_dialog.h
	service_response_time_dialog.h
	show_packet_bytes_dialog.h
	simple_statistics_dialog.h
	tlskeylog_launcher_dialog.h
	stats_tree_dialog.h
	strip_headers_dialog.h
	supported_protocols_dialog.h
	tabnav_tree_widget.h
	tap_parameter_dialog.h
	tcp_stream_dialog.h
	time_shift_dialog.h
	traffic_table_dialog.h
	uat_dialog.h
	uat_frame.h
	voip_calls_dialog.h
	welcome_page.h
	wireless_frame.h
	wireshark_application.h
	wireshark_dialog.h
	wireshark_main_window.h
	wlan_statistics_dialog.h
	${WIRESHARK_CUSTOM_QT_HEADERS}
)

if(ENABLE_PCAP)
	list(APPEND WIRESHARK_QT_HEADERS
		capture_info_dialog.h
	)
	if(HAVE_PCAP_REMOTE)
		list(APPEND WIRESHARK_QT_HEADERS
			remote_capture_dialog.h
			remote_settings_dialog.h
		)
	endif()
endif()

set(WIRESHARK_WIDGET_SRCS
	widgets/additional_toolbar.cpp
	widgets/apply_line_edit.cpp
	widgets/capture_filter_combo.cpp
	widgets/capture_filter_edit.cpp
	widgets/clickable_label.cpp
	widgets/compression_group_box.cpp
	widgets/copy_from_profile_button.cpp
	widgets/detachable_tabwidget.cpp
	widgets/display_filter_combo.cpp
	widgets/display_filter_edit.cpp
	widgets/dissector_syntax_line_edit.cpp
	widgets/dissector_tables_view.cpp
	widgets/drag_drop_toolbar.cpp
	widgets/drag_label.cpp
	widgets/editor_file_dialog.cpp
	widgets/elided_label.cpp
	widgets/expert_info_view.cpp
	widgets/export_objects_view.cpp
	widgets/field_filter_edit.cpp
	widgets/filter_expression_toolbar.cpp
	widgets/find_line_edit.cpp
	widgets/follow_stream_text.cpp
	widgets/hex_data_source_view.cpp
	widgets/interface_toolbar_lineedit.cpp
	widgets/json_data_source_view.cpp
	widgets/label_stack.cpp
	widgets/overlay_scroll_bar.cpp
	widgets/packet_list_header.cpp
	widgets/path_selection_edit.cpp
	widgets/pref_module_view.cpp
	widgets/profile_tree_view.cpp
	widgets/qcp_axis_ticker_elided.cpp
	widgets/qcp_axis_ticker_si.cpp
	widgets/qcp_spacer_legend_item.cpp
	widgets/qcp_string_legend_item.cpp
	widgets/range_syntax_lineedit.cpp
	widgets/resize_header_view.cpp
	widgets/resolved_addresses_view.cpp
	widgets/rowmove_tree_view.cpp
	widgets/rtp_audio_graph.cpp
	widgets/splash_overlay.cpp
	widgets/stock_icon_tool_button.cpp
	widgets/syntax_line_edit.cpp
	widgets/tabnav_tree_view.cpp
	widgets/traffic_tab.cpp
	widgets/traffic_tree.cpp
	widgets/traffic_types_list.cpp
	widgets/wireless_timeline.cpp
	widgets/wireshark_file_dialog.cpp
	widgets/customplot.cpp
)

set(WIRESHARK_3RD_PARTY_WIDGET_SRCS
	widgets/qcustomplot.cpp
)

set(WIRESHARK_MANAGER_SRCS
	manager/preference_manager.cpp
	manager/wireshark_preference.cpp
)

set(WIRESHARK_UTILS_SRCS
	utils/color_utils.cpp
	utils/data_printer.cpp
	utils/field_information.cpp
	utils/frame_information.cpp
	utils/profile_switcher.cpp
	utils/proto_node.cpp
	utils/qt_ui_utils.cpp
	utils/rtp_audio_file.cpp
	utils/rtp_audio_routing_filter.cpp
	utils/rtp_audio_routing.cpp
	utils/rtp_audio_silence_generator.cpp
	utils/stock_icon.cpp
	utils/wireshark_mime_data.cpp
	utils/wireshark_zip_helper.cpp
)

set(WIRESHARK_MODEL_SRCS
	models/astringlist_list_model.cpp
	models/atap_data_model.cpp
	models/cache_proxy_model.cpp
	models/coloring_rules_delegate.cpp
	models/coloring_rules_model.cpp
	models/column_list_model.cpp
	models/credentials_model.cpp
	models/decode_as_delegate.cpp
	models/decode_as_model.cpp
	models/dissector_tables_model.cpp
	models/enabled_protocols_model.cpp
	models/expert_info_model.cpp
	models/expert_info_proxy_model.cpp
	models/export_objects_model.cpp
	models/fileset_entry_model.cpp
	models/filter_list_model.cpp
	models/info_proxy_model.cpp
	models/interface_sort_filter_model.cpp
	models/interface_tree_cache_model.cpp
	models/interface_tree_model.cpp
	models/manuf_table_model.cpp
	models/numeric_value_chooser_delegate.cpp
	models/packet_list_model.cpp
	models/packet_list_record.cpp
	models/path_selection_delegate.cpp
	models/percent_bar_delegate.cpp
	models/pref_delegate.cpp
	models/pref_models.cpp
	models/profile_model.cpp
	models/proto_tree_model.cpp
	models/related_packet_delegate.cpp
	models/resolved_addresses_models.cpp
	models/sparkline_delegate.cpp
	models/supported_protocols_model.cpp
	models/timeline_delegate.cpp
	models/uat_delegate.cpp
	models/uat_model.cpp
	models/url_link_delegate.cpp
	models/voip_calls_info_model.cpp
)

set(WIRESHARK_QT_SRC
	about_dialog.cpp
	accordion_frame.cpp
	address_editor_frame.cpp
	bluetooth_att_server_attributes_dialog.cpp
	bluetooth_device_dialog.cpp
	bluetooth_devices_dialog.cpp
	bluetooth_hci_summary_dialog.cpp
	capture_comment_dialog.cpp
	capture_file_dialog.cpp
	capture_file_properties_dialog.cpp
	capture_file.cpp
	capture_filter_syntax_worker.cpp
	capture_options_dialog.cpp
	capture_preferences_frame.cpp
	coloring_rules_dialog.cpp
	column_editor_frame.cpp
	column_preferences_frame.cpp
	compiled_filter_output.cpp
	conversation_colorize_action.cpp
	conversation_dialog.cpp
	conversation_hash_tables_dialog.cpp
	credentials_dialog.cpp
	data_source_tab.cpp
	decode_as_dialog.cpp
	display_filter_expression_dialog.cpp
	dissector_tables_dialog.cpp
	enabled_protocols_dialog.cpp
	endpoint_dialog.cpp
	export_dissection_dialog.cpp
	export_object_action.cpp
	export_object_dialog.cpp
	export_pdu_dialog.cpp
	extcap_argument_file.cpp
	extcap_argument_multiselect.cpp
	extcap_argument.cpp
	extcap_options_dialog.cpp
	file_set_dialog.cpp
	filter_action.cpp
	filter_dialog.cpp
	filter_expression_frame.cpp
	firewall_rules_dialog.cpp
	follow_stream_action.cpp
	follow_stream_dialog.cpp

=== ui/stratoshark/CMakeLists.txt ===
# CMakeLists.txt
#
# Wireshark - Network traffic analyzer
# By Gerald Combs <gerald@wireshark.org>
# Copyright 1998 Gerald Combs
#
# SPDX-License-Identifier: GPL-2.0-or-later
#

if(USE_qt6)
  set(qtver "6")
else()
  set(qtver "5")
endif()

ADD_CUSTOM_CMAKE_INCLUDE()

set(WIRESHARK_WIDGET_HEADERS
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/additional_toolbar.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/apply_line_edit.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/base_data_source_view.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/capture_filter_combo.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/capture_filter_edit.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/clickable_label.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/compression_group_box.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/copy_from_profile_button.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/detachable_tabwidget.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/display_filter_combo.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/display_filter_edit.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/dissector_syntax_line_edit.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/dissector_tables_view.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/drag_drop_toolbar.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/drag_label.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/editor_file_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/elided_label.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/expert_info_view.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/field_filter_edit.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/filter_expression_toolbar.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/find_line_edit.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/follow_stream_text.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/hex_data_source_view.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/interface_toolbar_lineedit.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/json_data_source_view.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/label_stack.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/overlay_scroll_bar.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/packet_list_header.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/path_selection_edit.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/pref_module_view.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/profile_tree_view.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/qcp_axis_ticker_elided.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/qcp_axis_ticker_si.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/qcp_spacer_legend_item.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/qcp_string_legend_item.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/range_syntax_lineedit.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/resize_header_view.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/resolved_addresses_view.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/rowmove_tree_view.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/splash_overlay.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/stock_icon_tool_button.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/syntax_line_edit.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/tabnav_tree_view.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/traffic_tab.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/traffic_tree.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/traffic_types_list.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/wireshark_file_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/customplot.h
)

set (STRATOSHARK_WIDGET_HEADERS ${WIRESHARK_WIDGET_HEADERS})

set(WIRESHARK_3RD_PARTY_WIDGET_HEADERS
	${CMAKE_SOURCE_DIR}/ui/qt/widgets/qcustomplot.h
)

set (STRATOSHARK_3RD_PARTY_WIDGET_HEADERS ${WIRESHARK_3RD_PARTY_WIDGET_HEADERS})

set(WIRESHARK_MANAGER_HEADERS
	${CMAKE_SOURCE_DIR}/ui/qt/manager/preference_manager.h
	${CMAKE_SOURCE_DIR}/ui/qt/manager/wireshark_preference.h
)

set (STRATOSHARK_MANAGER_HEADERS ${WIRESHARK_MANAGER_HEADERS})

set(WIRESHARK_UTILS_HEADERS
	${CMAKE_SOURCE_DIR}/ui/qt/utils/color_utils.h
	${CMAKE_SOURCE_DIR}/ui/qt/utils/data_printer.h
	${CMAKE_SOURCE_DIR}/ui/qt/utils/field_information.h
	${CMAKE_SOURCE_DIR}/ui/qt/utils/frame_information.h
	${CMAKE_SOURCE_DIR}/ui/qt/utils/idata_printable.h
	${CMAKE_SOURCE_DIR}/ui/qt/utils/profile_switcher.h
	${CMAKE_SOURCE_DIR}/ui/qt/utils/proto_node.h
	${CMAKE_SOURCE_DIR}/ui/qt/utils/qt_ui_utils.h
	${CMAKE_SOURCE_DIR}/ui/qt/utils/stock_icon.h
	${CMAKE_SOURCE_DIR}/ui/qt/utils/tango_colors.h
	${CMAKE_SOURCE_DIR}/ui/qt/utils/variant_pointer.h
	${CMAKE_SOURCE_DIR}/ui/qt/utils/wireshark_mime_data.h
	${CMAKE_SOURCE_DIR}/ui/qt/utils/wireshark_zip_helper.h
)

set (STRATOSHARK_UTILS_HEADERS ${WIRESHARK_UTILS_HEADERS})

set(WIRESHARK_MODEL_HEADERS
	${CMAKE_SOURCE_DIR}/ui/qt/models/astringlist_list_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/atap_data_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/cache_proxy_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/coloring_rules_delegate.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/coloring_rules_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/column_list_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/decode_as_delegate.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/decode_as_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/dissector_tables_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/enabled_protocols_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/expert_info_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/expert_info_proxy_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/fileset_entry_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/filter_list_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/info_proxy_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/interface_sort_filter_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/interface_tree_cache_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/interface_tree_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/numeric_value_chooser_delegate.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/packet_list_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/packet_list_record.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/path_selection_delegate.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/percent_bar_delegate.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/pref_delegate.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/pref_models.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/profile_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/proto_tree_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/related_packet_delegate.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/resolved_addresses_models.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/sparkline_delegate.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/supported_protocols_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/timeline_delegate.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/tree_model_helpers.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/uat_delegate.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/uat_model.h
	${CMAKE_SOURCE_DIR}/ui/qt/models/url_link_delegate.h
)

set (STRATOSHARK_MODEL_HEADERS ${WIRESHARK_MODEL_HEADERS})

# All .h files which inherit from QObject aka which use the Q_OBJECT macro
# need to go here.
set(WIRESHARK_QT_HEADERS
	${CMAKE_SOURCE_DIR}/ui/qt/about_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/accordion_frame.h
	${CMAKE_SOURCE_DIR}/ui/qt/address_editor_frame.h
	${CMAKE_SOURCE_DIR}/ui/qt/capture_comment_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/capture_file_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/capture_file_properties_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/capture_file.h
	${CMAKE_SOURCE_DIR}/ui/qt/capture_filter_syntax_worker.h
	${CMAKE_SOURCE_DIR}/ui/qt/capture_options_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/capture_preferences_frame.h
	${CMAKE_SOURCE_DIR}/ui/qt/coloring_rules_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/column_editor_frame.h
	${CMAKE_SOURCE_DIR}/ui/qt/column_preferences_frame.h
	${CMAKE_SOURCE_DIR}/ui/qt/compiled_filter_output.h
	${CMAKE_SOURCE_DIR}/ui/qt/conversation_colorize_action.h
	${CMAKE_SOURCE_DIR}/ui/qt/conversation_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/conversation_hash_tables_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/data_source_tab.h
	${CMAKE_SOURCE_DIR}/ui/qt/decode_as_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/display_filter_expression_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/dissector_tables_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/enabled_protocols_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/endpoint_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/expert_info_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/export_dissection_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/extcap_argument_file.h
	${CMAKE_SOURCE_DIR}/ui/qt/extcap_argument_multiselect.h
	${CMAKE_SOURCE_DIR}/ui/qt/extcap_argument.h
	${CMAKE_SOURCE_DIR}/ui/qt/extcap_options_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/file_set_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/filter_action.h
	${CMAKE_SOURCE_DIR}/ui/qt/filter_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/filter_expression_frame.h
	${CMAKE_SOURCE_DIR}/ui/qt/follow_stream_action.h
	${CMAKE_SOURCE_DIR}/ui/qt/follow_stream_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/font_color_preferences_frame.h
	${CMAKE_SOURCE_DIR}/ui/qt/funnel_statistics.h
	${CMAKE_SOURCE_DIR}/ui/qt/funnel_string_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/funnel_text_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/geometry_state_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/glib_mainloop_on_qeventloop.h
	${CMAKE_SOURCE_DIR}/ui/qt/graph.h
	${CMAKE_SOURCE_DIR}/ui/qt/import_text_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/interface_frame.h
	${CMAKE_SOURCE_DIR}/ui/qt/interface_toolbar_reader.h
	${CMAKE_SOURCE_DIR}/ui/qt/interface_toolbar.h
	${CMAKE_SOURCE_DIR}/ui/qt/io_console_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/io_graph.h
	${CMAKE_SOURCE_DIR}/ui/qt/io_graph_action.h
	${CMAKE_SOURCE_DIR}/ui/qt/io_graph_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/layout_preferences_frame.h
	${CMAKE_SOURCE_DIR}/ui/qt/main_application.h
	${CMAKE_SOURCE_DIR}/ui/qt/main_status_bar.h
	${CMAKE_SOURCE_DIR}/ui/qt/main_window_preferences_frame.h
	${CMAKE_SOURCE_DIR}/ui/qt/main_window.h
	${CMAKE_SOURCE_DIR}/ui/qt/manage_interfaces_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/module_preferences_scroll_area.h
	${CMAKE_SOURCE_DIR}/ui/qt/packet_comment_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/packet_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/packet_format_group_box.h
	${CMAKE_SOURCE_DIR}/ui/qt/packet_format_stack.h
	${CMAKE_SOURCE_DIR}/ui/qt/packet_list.h
	${CMAKE_SOURCE_DIR}/ui/qt/packet_range_group_box.h
	${CMAKE_SOURCE_DIR}/ui/qt/plot.h
	${CMAKE_SOURCE_DIR}/ui/qt/plot_action.h
	${CMAKE_SOURCE_DIR}/ui/qt/plot_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/preference_editor_frame.h
	${CMAKE_SOURCE_DIR}/ui/qt/preferences_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/print_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/profile_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/progress_frame.h
	${CMAKE_SOURCE_DIR}/ui/qt/proto_tree.h
	${CMAKE_SOURCE_DIR}/ui/qt/protocol_hierarchy_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/protocol_preferences_menu.h
	${CMAKE_SOURCE_DIR}/ui/qt/recent_file_status.h
	${CMAKE_SOURCE_DIR}/ui/qt/resolved_addresses_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/response_time_delay_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/rsa_keys_frame.h
	${CMAKE_SOURCE_DIR}/ui/qt/search_frame.h
	# XXX Depends on RTP Stream Dialog
	# ${CMAKE_SOURCE_DIR}/ui/qt/sequence_diagram.h
	# ${CMAKE_SOURCE_DIR}/ui/qt/sequence_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/show_packet_bytes_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/simple_statistics_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/stats_tree_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/keyboard_shortcuts_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/supported_protocols_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/tabnav_tree_widget.h
	${CMAKE_SOURCE_DIR}/ui/qt/tap_parameter_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/tcp_stream_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/time_shift_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/traffic_table_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/uat_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/uat_frame.h
	${CMAKE_SOURCE_DIR}/ui/qt/welcome_page.h
	${CMAKE_SOURCE_DIR}/ui/qt/wireshark_dialog.h
	${CMAKE_SOURCE_DIR}/ui/qt/marker_dialog.h
)

if(WIRESHARK_CUSTOM_QT_HEADERS)
	list(APPEND WIRESHARK_QT_HEADERS
		${CMAKE_SOURCE_DIR}/ui/qt/${WIRESHARK_CUSTOM_QT_HEADERS}
	)
endif()

if(ENABLE_PCAP)
	list(APPEND WIRESHARK_QT_HEADERS
		${CMAKE_SOURCE_DIR}/ui/qt/capture_info_dialog.h
	)
	if(HAVE_PCAP_REMOTE)
		list(APPEND WIRESHARK_QT_HEADERS
			${CMAKE_SOURCE_DIR}/ui/qt/remote_capture_dialog.h
			${CMAKE_SOURCE_DIR}/ui/qt/remote_settings_dialog.h
		)
	endif()
endif()

set (STRATOSHARK_QT_HEADERS
	stratoshark_application.h
	stratoshark_main_window.h
	stratoshark_about_dialog.h
	stratoshark_capture_file_properties_dialog.h
	stratoshark_follow_stream_dialog.h
	stratoshark_io_graph_dialog.h
	stratoshark_main_status_bar.h
	stratoshark_plot_dialog.h
	stratoshark_profile_dialog.h
	stratoshark_search_frame.h
	stratoshark_welcome_page.h
	${WIRESHARK_QT_HEADERS}
)

set(WIRESHARK_WIDGET_SRCS

=== epan/dissectors/asn1/acse/CMakeLists.txt ===
# CMakeLists.txt
#
# Wireshark - Network traffic analyzer
# By Gerald Combs <gerald@wireshark.org>
# Copyright 1998 Gerald Combs
#
# SPDX-License-Identifier: GPL-2.0-or-later
#

set( PROTOCOL_NAME acse )

set( PROTO_OPT )

set( EXPORT_FILES
	${PROTOCOL_NAME}-exp.cnf
)

set( EXT_ASN_FILE_LIST
)

set( ASN_FILE_LIST
	${PROTOCOL_NAME}.asn
)

set( EXTRA_DIST
	${ASN_FILE_LIST}
	packet-${PROTOCOL_NAME}-template.c
	packet-${PROTOCOL_NAME}-template.h
	${PROTOCOL_NAME}.cnf
)

set( SRC_FILES
	${EXTRA_DIST}
	${EXT_ASN_FILE_LIST}
)

set( A2W_FLAGS -b )

set( EXTRA_CNF
	"${CMAKE_CURRENT_BINARY_DIR}/../x509if/x509if-exp.cnf"
)

set( EXPORT_DEPENDS
	"${CMAKE_CURRENT_BINARY_DIR}/../x509if/x509if-exp.cnf"
)

ASN2WRS()

=== epan/dissectors/asn1/camel/CMakeLists.txt ===
# CMakeLists.txt
#
# Wireshark - Network traffic analyzer
# By Gerald Combs <gerald@wireshark.org>
# Copyright 1998 Gerald Combs
#
# SPDX-License-Identifier: GPL-2.0-or-later
#

set( PROTOCOL_NAME camel )

set( PROTO_OPT )

set( EXT_ASN_FILE_LIST
)

set( EXT_ASN_FILE_LIST_LATE
	../ros/Remote-Operations-Information-Objects.asn
	../ros/Remote-Operations-Generic-ROS-PDUs.asn
)

set( ASN_FILE_LIST
	CAP-object-identifiers.asn
	CAP-classes.asn
	CAP-datatypes.asn
	CAP-errorcodes.asn
	CAP-errortypes.asn
	CAP-operationcodes.asn
	CAP-GPRS-ReferenceNumber.asn
	CAP-gsmSCF-gsmSRF-ops-args.asn
	CAP-gsmSSF-gsmSCF-ops-args.asn
	CAP-gprsSSF-gsmSCF-ops-args.asn
	CAP-SMS-ops-args.asn
	CAP-U-ABORT-Data.asn
	CamelV2diff.asn
)

set( EXTRA_DIST
	${ASN_FILE_LIST}
	packet-${PROTOCOL_NAME}-template.c
	packet-${PROTOCOL_NAME}-template.h
	${PROTOCOL_NAME}.asn
	${PROTOCOL_NAME}.cnf
)

set( SRC_FILES
	${EXTRA_DIST}
	${EXT_ASN_FILE_LIST}
)

set( A2W_FLAGS -b -N )

set( EXTRA_CNF
	"${CMAKE_CURRENT_BINARY_DIR}/../inap/inap-exp.cnf"
	"${CMAKE_CURRENT_BINARY_DIR}/../gsm_map/gsm_map-exp.cnf"
)

ASN2WRS()

=== packaging/debian/changelog ===
wireshark (4.7.0rc0-1571-g59eba0ae571e) UNRELEASED; urgency=low

  * Self-made package

 -- Wireshark Self-made package <wireshark@example.com>  Mon, 17 Oct 2016 12:05:44 +0200

=== packaging/debian/control ===
Source: wireshark
Section: net
Priority: optional
Maintainer: Wireshark Self-made package <wireshark@example.com>
Standards-Version: 3.9.8
# Should be roughly in sync with https://salsa.debian.org/debian/wireshark/-/blob/debian/master/debian/control
Build-Depends: asciidoctor,
               cmake (>= 3.5),
               debhelper (>= 12),
               dh-python,
               docbook-xml,
               docbook-xsl,
               flex,
               libbcg729-dev,
               libbrotli-dev,
               libc-ares-dev,
               libcap2-dev | libcap-dev,
               libgcrypt-dev,
               libglib2.0-dev,
               libgnutls28-dev,
               libkrb5-dev,
               liblua5.4-dev | liblua5.3-dev,
               liblz4-dev,
               libmaxminddb-dev,
               libminizip-dev,
               libnghttp2-dev,
               libnghttp3-dev,
               libnl-genl-3-dev [linux-any],
               libnl-route-3-dev [linux-any],
               libopencore-amrnb-dev,
               libopus-dev,
               libparse-yapp-perl,
               libpcap0.8-dev,
               libsbc-dev,
               libsmi2-dev,
               libsnappy-dev,
               libspandsp-dev,
               libspeexdsp-dev,
               libssh-dev (>= 0.11.1-1) | libssh-gcrypt-dev,
               libsystemd-dev,
               libxkbcommon-dev,
               libxml2-dev,
               libxml2-utils,
               libz-dev,
               libzstd-dev,
               lsb-release,
               po-debconf,
               python3-ply,
               python3-pytest <!nocheck>,
               python3-pytest-xdist <!nocheck>,
               python3,
               qt6-5compat-dev | libqt6core5compat6-dev,
               qt6-base-dev-tools,
               qt6-base-dev,
               qt6-multimedia-dev,
               qt6-tools-dev,
               quilt,
               xsltproc,
               libfalcosecurity0-dev <pkg.wireshark.stratoshark>
Build-Conflicts: libsnmp4.2-dev, libsnmp-dev
Vcs-Git: https://salsa.debian.org/debian/wireshark -b debian/master
Vcs-Browser: https://salsa.debian.org/debian/wireshark.git
Homepage: https://www.wireshark.org/

Package: wireshark-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libwireshark0 (>= ${binary:Version}),
 libwiretap0 (>= ${binary:Version}), libuiqt-plugin0 (>= ${binary:Version}), debconf, libcap2-bin [linux-any]
Recommends: wireshark (>= ${binary:Version}) | tshark (>= ${binary:Version})
Breaks: wireshark (<< 2.0.0~),
        wireshark-gtk (<< 3.0.0),
        wireshark-qt (<< 2.0.0~rc3+g841d5e1)
Replaces: wireshark (<< 2.0.0~),
        wireshark-qt (<< 2.0.0~rc3+g841d5e1)
Description: network traffic analyzer - common files
 Wireshark is a network "sniffer" - a tool that captures and analyzes
 packets off the wire. Wireshark can decode too many protocols to list
 here.
 .
 This package provides files common to both wireshark and tshark
 (the console version).

Package: wireshark
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         wireshark-common (= ${binary:Version}),
         libqt6svg6,
         qt6-qpa-plugins
Recommends: libqt6multimedia6
Breaks: libwireshark-data (<< 4.4.3-2~),
        wireshark-qt,
        wireshark-gtk (<< 3.0.0~)
Replaces: libwireshark-data (<< 4.4.3-2~),
          wireshark-qt,
          wireshark-gtk (<< 3.0.0~)
Description: network traffic analyzer - graphical interface
 Wireshark is a network "sniffer" - a tool that captures and analyzes
 packets off the wire. Wireshark can decode too many protocols to list
 here.

# We override the binary version, so use the source version here.
Package: stratoshark
Build-Profiles: <pkg.wireshark.stratoshark>
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         wireshark-common (= ${source:Version}),
         libfalcosecurity0t64,
         libqt6svg6,
         qt6-qpa-plugins
# Recommends: libqt6multimedia6
Suggests: falcosecurity-scap-dkms
Description: system call and log analyzer - graphical and console interfaces
 Stratoshark is a system call and log analyzer. It can capture and analyze
 system calls on Linux and capture and analyze log data from other sources.
 .
 The package provides stratoshark as the graphical interface and strato
 as the console interface.

Package: tshark
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, wireshark-common (= ${binary:Version})
Description: network traffic analyzer - console version
 Wireshark is a network "sniffer" - a tool that captures and analyzes
 packets off the wire. Wireshark can decode too many protocols to list
 here.
 .
 This package provides the console version of wireshark, named
 "tshark".

Package: wireshark-dev
Architecture: any
Section: devel
Depends: ${misc:Depends}, omniidl (>= 4.0.1-2), libpcap0.8-dev,
 libglib2.0-dev, python3:any, python3-ply, esnacc,
 libwireshark-dev, libwiretap-dev
Description: network traffic analyzer - development tools
 Wireshark is a network "sniffer" - a tool that captures and analyzes
 packets off the wire. Wireshark can decode too many protocols to list
 here.
 .
 This package provides idl2wrs and other files necessary for developing
 new packet dissectors.

Package: wireshark-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: network traffic analyzer - documentation
 Wireshark is a network "sniffer" - a tool that captures and analyzes
 packets off the wire. Wireshark can decode too many protocols to list
 here.
 .
 This package contains Wireshark User's guide, Wireshark Developer's Guide
 and the Lua Reference.

Package: libwireshark0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libwireshark-data (>= ${source:Version}),
 libwsutil0 (>= ${source:Version})
Suggests: wireshark-doc (>= ${source:Version})
Description: network packet dissection library -- shared library
 The libwireshark library provides the network packet dissection services
 developed by the Wireshark project.

Package: libwsutil0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: network packet dissection utilities library -- shared library
 The libwsutil library provides utility functions for libwireshark0.

Package: libwsutil-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends} , libwsutil0 (= ${binary:Version})
Breaks: libwireshark-dev (<< 3.7.0~)
Replaces: libwireshark-dev (<< 3.7.0~)
Description: network packet dissection utilities library -- development files
 The libwsutil library provides utility functions for libwireshark6.
 .
 This package contains the static library and the C header files that are
 needed for applications to use the libwsutil library.

Package: libwireshark-data
Section: libs
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
#Recommends: geoip-database-contrib # Only includes legacy?
Suggests: snmp-mibs-downloader
Description: network packet dissection library -- data files
 The libwireshark library provides the network packet dissection services
 developed by the Wireshark project.
 .
 This package contains the platform independent files.

Package: libwireshark-dev
Section: libdevel
Depends: ${misc:Depends}, libwsutil-dev, libwiretap-dev,
 libwireshark0 (= ${binary:Version})
Architecture: any
Description: network packet dissection library -- development files
 The "libwireshark" library provides the network packet dissection services
 developed by the Wireshark project.
 .
 This package contains the static library and the C header files that are
 needed for applications to use libwireshark services.

Package: libwiretap0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: network packet capture library -- shared library
 Wiretap, part of the Wireshark project, is a library that allows one to
 read and write several packet capture file formats.
 .
 Supported formats are:
  * Libpcap
  * Sniffer
  * LANalyzer
  * Network Monitor
  * "snoop"
  * "iptrace"
  * Sniffer Basic (NetXRay)/Windows Sniffer Pro
  * RADCOM WAN/LAN Analyzers
  * Lucent/Ascend access products
  * HP-UX nettl
  * Toshiba ISDN Router
  * ISDN4BSD "i4btrace" utility
  * Cisco Secure Intrusion Detection System iplogging facility
  * pppd logs (pppdump-format files)
  * VMS TCPTRACE
  * DBS Etherwatch (text format)
  * Catapult DCT2000 (.out files)
 .
 Wiretap's shortcomings are: no filter capability and no support for packet
 capture.

Package: libwiretap-dev
Section: libdevel
Depends: ${misc:Depends}, libwsutil-dev, libwiretap0 (= ${binary:Version})
Architecture: any
Description: network packet capture library -- development files
 Wiretap, part of the Wireshark project, is a library that allows one to
 read and write several packet capture file formats.
 .
 Supported formats are:
  * Libpcap
  * Sniffer
  * LANalyzer
  * Network Monitor
  * "snoop"
  * "iptrace"
  * Sniffer Basic (NetXRay)/Windows Sniffer Pro
  * RADCOM WAN/LAN Analyzers
  * Lucent/Ascend access products
  * HP-UX nettl
  * Toshiba ISDN Router
  * ISDN4BSD "i4btrace" utility
  * Cisco Secure Intrusion Detection System iplogging facility
  * pppd logs (pppdump-format files)
  * VMS TCPTRACE
  * DBS Etherwatch (text format)
  * Catapult DCT2000 (.out files)
 .
 Wiretap's shortcomings are: no filter capability and no support for packet
 capture.
 .
 This package contains the static library and the C header files.

Package: libuiqt-plugin0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}
Description: Qt-based UI plugin library -- shared library
 QtUIPlugin, part of the Wireshark project, is a library that allows one to
 create UI extensions through menu options
